with
   Ada.Text_Io,
   Paskma.Time_Utilities;
use
   Ada.Text_Io,
   Paskma.Time_Utilities;

package body Paskma.Logger is

   Log_File : File_Type;  

   --------------
   -- Init_Log --
   --------------
   procedure Init_Log (
         Filename : String ) is 
   begin
      Create(Log_File, Out_File, Filename);
      New_Line(Log_File);
      Put(Log_File, "    Start: " & To_String(Get_Current_Date) & "   " & To_String(Get_Current_Time));
      New_Line(Log_File, 2);
   end Init_Log;

   ---------
   -- Log --
   ---------

   procedure Log (
         Message : Unbounded_String ) is 
   begin
      Log(To_String(Message));
   end Log;

   procedure Log (
         Message : String ) is 
   begin
      Put_Line(Log_File, To_String(Get_Current_Time) & " : " & Message);
   end;

   procedure Log (
         Id      : Integer; 
         Message : String   ) is 
   begin
      Log(" -" & Integer'Image(Id) & "- " & Message);
   end;
   
   procedure Log (
         Id      : Integer; 
         Message : unbounded_String   ) is
   begin
      Log(Id, To_String(Message));
      end;

   procedure Flush_Log is 
   begin
      Flush(Log_File);
   end;

   procedure Close_Log is 
   begin
      Close(Log_File);
   end;

end Paskma.Logger;

