with Ada.Strings.Unbounded,
   Paskma.Lists;

use Ada.Strings.Unbounded;

package Paskma.String_Utilities is

   package String_Lists is new Paskma.Lists(Unbounded_String);
   use String_Lists;

   ----------------------------------------------------------------------------------

   function Insensitive_Compare (
         Left,                    
         Right : Unbounded_String ) 
     return Boolean; 

   ----------------------------------------------------------------------------------

   function Insensitive_Compare (
         Left,          
         Right : String ) 
     return Boolean; 

   ----------------------------------------------------------------------------------

   function Insensitive_Compare (
         Left  : Unbounded_String; 
         Right : String            ) 
     return Boolean; 

   ----------------------------------------------------------------------------------

   function Insensitive_Compare (
         Left  : String;          
         Right : Unbounded_String ) 
     return Boolean; 

   ----------------------------------------------------------------------------------

   function Hash (
         S : Unbounded_String ) 
     return Integer; 

   ----------------------------------------------------------------------------------

   procedure Get_Elements (
         S         :        Unbounded_String; 
         Delimiter :        Character;        
         Result    : in out List              ); 

   ----------------------------------------------------------------------------------

   function "+" (
         Source : String ) 
     return Unbounded_String; 

   ----------------------------------------------------------------------------------

   function "+" (
         Source : Unbounded_String ) 
     return String; 

end Paskma.String_Utilities;