with System,
   Ada.Characters.Latin_1,
   Ada.Strings.Fixed,
   Ada.Unchecked_Conversion;

use System,
   Ada.Strings.Fixed;

package body C_Conversions is
   function To_Lpcstr (
         A : String ) 
     return Lpcstr is 
      -- the given input must contain ending NULL terminator

      function Convert is 
      new Ada.Unchecked_Conversion(System.Address, Lpcstr);

   begin
      return Convert(A(A'First)'Address);
   end To_Lpcstr;

   --------------------------------------------------------------------------------

   function To_String (
         Data : Char_Array ) 
     return String is 

      Result              : String (1 .. Data'Last - Data'First + 1);  
      Zero                : String (1 .. 1);  
      Terminator_Position : Natural;  
   begin
      for I in Result'range loop
         Result(I) := Character(Data(I-1));
      end loop;

      Zero(1) := Ada.Characters.Latin_1.Nul;
      Terminator_Position := Index(Result, Zero);

      if Terminator_Position = 0 then
         -- there is not NULL terminator
         return Result;
      else
         -- the NULL was found
         return Result(1..Terminator_Position-1);
         -- cut off the end NULL terminator
      end if;

   end To_String;


end C_Conversions;

