with Gnat.Sockets,
   Ada.Text_Io,
   Ada.Strings.Unbounded,
   Ada.Exceptions;

use Gnat.Sockets,
   Ada.Text_Io,
   Ada.Strings.Unbounded,
   Ada.Exceptions;



procedure Namer is 
   Buffer : String (1 .. 128);  
   Last   : Natural;  
   Host   : Inet_Addr_Type;  


begin
   begin
      Gnat.Sockets.Initialize(True);

      Put_Line("Insert IP address:");
      Get_Line(Buffer, Last);
      if Last = 0 then
         Put("empty");
         return;
      end if;

      Host:= Inet_Addr(Buffer(1..Last));

      Put_Line("The determined IP address is:");
      Put_Line(Image(Host));

      Put_Line("The oficial name is:");
      Put_Line(Official_Name(Get_Host_By_Address(Host)));

      Gnat.Sockets.Finalize;

   exception
      when Host_Error =>
         Put_Line("Cannot determine host name.");
      when Constraint_Error =>
         Put_Line("Bad data.");
      when Event : others =>
         Put_Line("Unexpected exception:");
         Put_Line(Exception_Information(Event));
   end;

   Put_Line("<enter> to continue...");
   Get_Line(Buffer, Last);
end;