with Ada.Characters.Handling;

use Ada.Characters.Handling;

package body Pi_Commands is

   --
   -- Compare
   --
   -- private function, case insensitive

   function Compare (
         Command_Pattern : String; 
         -- should be 1..n          
         Command_From_Line : Unbounded_String ) 
     return Boolean is 

      Upper_Command_Pattern   : String (Command_Pattern'range);  
      Upper_Command_From_Line : String (1 .. Length (Command_From_Line));  
   begin
      Upper_Command_Pattern := To_Upper(Command_Pattern);
      Upper_Command_From_Line := To_Upper(To_String(Command_From_Line));

      return Upper_Command_Pattern = Upper_Command_From_Line;

   exception

      when Constraint_Error =>
         return False;
   end;


   ----------------
   -- To_Command --
   ----------------

   function To_Command (
         Line : Unbounded_String ) 
     return Command_Type is 
   begin
      if Compare("user", Line) then
         return The_User;
      elsif Compare("pass", Line) then
         return The_Pass;
      elsif Compare("pwd", Line) then
         return The_Pwd;
      elsif Compare("xpwd", Line) then
         return The_Xpwd;
      elsif Compare("cwd", Line) then
         return The_Cwd;
      elsif Compare("cdup", Line) then
         return The_Cdup;
      elsif Compare("xcup", Line) then
         return The_Xcup;
      elsif Compare("list", Line) then
         return The_List;
      elsif Compare("nlst", Line) then
         return The_Nlst;
      elsif Compare("port", Line) then
         return The_Port;
      elsif Compare("mode", Line) then
         return The_Mode;
      elsif Compare("type", Line) then
         return The_Type;
      elsif Compare("retr", Line) then
         return The_Retr;
      elsif Compare("stor", Line) then
         return The_Stor;
      elsif Compare("appe", Line) then
         return The_Appe;
      elsif Compare("rest", Line) then
         return The_Rest;
      elsif Compare("dele", Line) then
         return The_Dele;
      elsif Compare("mkd", Line) then
         return The_Mkd;
      elsif Compare("xmkd", Line) then
         return The_Xmkd;
      elsif Compare("rmd", Line) then
         return The_Rmd;
      elsif Compare("xrmd", Line) then
         return The_Xrmd;
      elsif Compare("rnfr", Line) then
         return The_Rnfr;
      elsif Compare("rnto", Line) then
         return The_Rnto;
      elsif Compare("quit", Line) then
         return The_Quit;
      elsif Compare("syst", Line) then
         return The_Syst;
      elsif Compare("acct", Line) then
         return The_Acct;
      elsif Compare("allo", Line) then
         return The_Allo;
      elsif Compare("site", Line) then
         return The_Site;
      elsif Compare("noop", Line) then
         return The_Noop;
      elsif Compare("help", Line) then
         return The_Help;
      elsif Compare("pasv", Line) then
         return The_Pasv;
      else
         raise Invalid_Command;
      end if;

   end To_Command;

end Pi_Commands;

