with Gnat.Sockets,
   Reply_Codes,
   Ada.Strings.Unbounded,
   Task_Id_Types,
   Pi_Commands;

use Gnat.Sockets,
   Reply_Codes,
   Ada.Strings.Unbounded,
   Task_Id_Types,
   Pi_Commands;

package Pi_Conversion_Layer is

   procedure Send_Reply (
         To_Socket   : Socket_Type;     
         Of_Code     : Reply_Code_Type; 
         And_Message : Unbounded_String ); 

   procedure Send_Reply (
         To_Socket   : Socket_Type;     
         Of_Code     : Reply_Code_Type; 
         And_Message : String           ); 

   procedure Parse (
         Line      :        Unbounded_String; 
         Command   :    out Command_Type;     
         Parameter :    out Unbounded_String  ); 

   procedure Log (
         Task_Id : Task_Id_Type;    
         Code    : Reply_Code_Type; 
         Message : String           ); 

   procedure Log (
         Task_Id : Task_Id_Type;    
         Code    : Reply_Code_Type; 
         Message : Unbounded_String ); 

   function Ftp_Address_To_Socket_Address (
         Ftp_Addr : Unbounded_String ) 
     return Sock_Addr_Type; 

   function Socket_Address_To_Ftp_Address (
         Socket_Address : Sock_Addr_Type ) 
     return Unbounded_String; 

end Pi_Conversion_Layer;