with Ada.Streams,
   Gnat.Sockets,
   Ada.Strings.Unbounded,
   Ada.Characters.Latin_1,
   Ada.Streams.Stream_Io;

use Ada.Streams,
   Ada.Strings.Unbounded,
   Gnat.Sockets,
   Ada.Streams.Stream_Io;

package Socket_Utilities is

   Crlf : constant String (1 .. 2) := Ada.Characters.Latin_1.Cr & Ada.Characters.Latin_1.Lf;  

   --------------------------------------------------------------------------------
   --   procedure Sure_Send_Socket (
   --         Socket : Socket_Type;         
   --         Buffer : Stream_Element_Array ); 
   --------------------------------------------------------------------------------
   function To_String (
         Buf  : Stream_Element_Array; 
         Last : Stream_Element_Offset ) 
     return Unbounded_String; 

   --------------------------------------------------------------------------------

   function To_Stream (
         Buf : Unbounded_String ) 
     return Stream_Element_Array; 

   --------------------------------------------------------------------------------

   procedure Copy_File_To_Socket (
         File   : File_Type;  
         Socket : Socket_Type ); 

   --------------------------------------------------------------------------------

   procedure Copy_Socket_To_File (
         Socket : Socket_Type;        
         File   : Stream_Io.File_Type ); 

   --------------------------------------------------------------------------------

   procedure Write_Line (
         Socket : Socket_Type;     
         Line   : Unbounded_String ); 

   --------------------------------------------------------------------------------

   function Read_Line (
         Socket : Socket_Type ) 
     return Unbounded_String; 

   --------------------------------------------------------------------------------

end Socket_Utilities;