with Paskma.Logger;
use Paskma.Logger;

package body Task_Id_Types is
   --
   -- Log
   --
   -- Logging procedure for task_id_type

   procedure Log (
         Id      : Task_Id_Type; 
         Message : String        ) is 
   begin
      Log(Integer(Id), Message);
   end;

   procedure Log (
         Id      : Task_Id_Type;    
         Message : Unbounded_String ) is 
   begin
      Log(Integer(Id), Message);
   end;

   --
   -- Task_Id_Generator
   --
   -- guarantees the thread safe result

   protected body Task_Id_Generator is
      procedure Get_New_Task_Id (
            Result :    out Task_Id_Type ) is 
      begin
         Task_Id_Counter := Task_Id_Counter +1;
         Result := Task_Id_Counter;
      end Get_New_Task_Id;

   end Task_Id_Generator;

   --
   -- And the only instance
   --

   The_Generator : Task_Id_Generator;  

   --
   -- Unique_task_id 
   --
   function Unique_Task_Id return Task_Id_Type is 

      Result : Task_Id_Type;  
   begin
      The_Generator.Get_New_Task_Id(Result);
      return Result;
   end Unique_Task_Id;

end Task_Id_Types;

