unit TaskBarIcon;

interface

uses
  Windows, ShellApi, Messages;

function MyTaskBarAddIcon(hwnd:HWND;uID:UINT;hicon:HICON;lpszTip:LPSTR): BOOL;
function MyTaskBarChangeIcon(hwnd:HWND;uID:UINT;hicon:HICON;lpszTip:LPSTR): BOOL;
function MyTaskBarDeleteIcon(hwnd:HWND;uID:UINT): BOOL; 

implementation

function MyTaskBarAddIcon(hwnd:HWND;uID:UINT;hicon:HICON;lpszTip:LPSTR): BOOL;
var res: BOOL;
   tnid: TNOTIFYICONDATA;
begin 
 tnid.cbSize:=sizeof(TNOTIFYICONDATA);
 tnid.Wnd:=hwnd;
 tnid.uID:=uID;
 tnid.uFlags:=NIF_MESSAGE or NIF_ICON or NIF_TIP;
 tnid.uCallbackMessage:=WM_USER;
 tnid.hIcon:=hicon;
 if BOOL(lpszTip) then lstrcpyn(tnid.szTip,lpszTip,sizeof(tnid.szTip)) 
                  else tnid.szTip[0] := #0; 
 res:=Shell_NotifyIcon(NIM_ADD, @tnid);
 if BOOL(hicon) then DestroyIcon(hicon); 
 result := res;
end;

function MyTaskBarChangeIcon(hwnd:HWND;uID:UINT;hicon:HICON;lpszTip:LPSTR): BOOL;
var res:BOOL; 
   tnid:TNOTIFYICONDATA; 
begin 
 tnid.cbSize:=sizeof(TNOTIFYICONDATA); 
 tnid.Wnd:=hwnd;
 tnid.uID:=uID; 
 tnid.uFlags:=NIF_MESSAGE or NIF_ICON or NIF_TIP;
 tnid.uCallbackMessage:=WM_USER; 
 tnid.hIcon:=hicon;
 if BOOL(lpszTip) then lstrcpyn(tnid.szTip,lpszTip,sizeof(tnid.szTip)) 
                  else tnid.szTip[0]:=#0; 
 res:=Shell_NotifyIcon(NIM_MODIFY, @tnid); 
 if BOOL(hicon) then DestroyIcon(hicon); 
 result:=res;
end;

function MyTaskBarDeleteIcon(hwnd:HWND;uID:UINT): BOOL;
var res:BOOL; 
   tnid:TNOTIFYICONDATA; 
begin
 tnid.cbSize:=sizeof(TNOTIFYICONDATA);
 tnid.Wnd:=hwnd; 
 tnid.uID:=uID; 
 res:=Shell_NotifyIcon(NIM_DELETE, @tnid); 
 result:=res;
end;
end.
